/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *    http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
#ifndef _CCPRESTCLIENT_H_
#define _CCPRESTCLIENT_H_

#include "CCPRestDefine.h"

#ifndef __cplusplus
typedef enum {false, true} bool;
#endif

#ifdef __cplusplus
extern "C" {
#endif
/////////////////////////////////////////////////////////////////////////////////////////////////////
//־
#define LOG_PACKAGE 5
#define LOG_DEBUG   4
#define LOG_INFO    3
#define LOG_ERROR   2
#define LOG_OPEN    1
#define LOG_CLOSE   0

enum {//ش󷵻ֵ
	ERR_LOCAL_NET =172001,//
	ERR_LOCAL_NO_RETURN,//޷
	ERR_LOCAL_NO_RETURN_BODY,//޷ذ
	ERR_LOCAL_IP_NULL,//IP
	ERR_LOCAL_IP_PORT,//˿ڴСڵ0
	ERR_LOCAL_ACCOUNT_NULL,//˺ſ
	ERR_LOCAL_ACCOUNT_TOKEN_NULL,//˺ƿ
    ERR_LOCAL_SUBACCOUNT_NULL,//˺ſ
	ERR_LOCAL_SUBACCOUNT_TOKEN_NULL,//˺ƿ
	ERR_LOCAL_VOIP_NULL,//VoIPſ
	ERR_LOCAL_VOIP_TOKEN_NULL,//VoIPƿ
    ERR_LOCAL_APPID_NULL,//ӦID
};
enum {//rest  ش󷵻ֵ

	ERR_REST_NULL =171300,
	ERR_REST_MD5_BASE64,
	ERR_REST_SYN_HTTP_REQUEST,//socketʧ
	ERR_REST_SYN_HTTP_STATAUS_CODE,
	ERR_REST_CREATE_FILE,
	ERR_REST_XML_NODE,
	ERR_REST_XML_ELEMENT,
	ERR_REST_XML_STATAUS_CODE,
	ERR_REST_XML_FILESTATAUS_CODE,
	ERR_REST_QUEUE_EMPTY,
	ERR_REST_XML_SWITCHIP_NULL,
	ERR_REST_ENCODE_HTTP,
	ERR_REST_RECV_NULL,
	ERR_REST_BODY_NULL,//ݿ
	ERR_REST_HEAD_LARGE,//ͷ̫
	ERR_REST_RESPONSE_CONTENT_LENGTH,//ضư峤
	ERR_REST_CANCEL_UP_OR_DOWM_NOW,//ⲿȡϴ
	ERR_REST_SEND_WSAECONNRESET,//·Զ˸λ
	ERR_REST_RECV_BLOCK,//ʱmsglen=0֣ʱӦ˳Ż ѭ˳
	ERR_REST_UNICODE_TO_UTF8_MORE_LEN,//ַ̫
};
enum {//body
     HTTP_BODY_TYPE_XML= 0x00,
     HTTP_BODY_TYPE_JSON,

};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//ʼò
	/*! @function
	********************************************************************************
	   : init
	     : ʼʼȫֶ
	     : [IN]  rest_addr : ͨѶƽַ̨
			   [IN]  rest_port : ˿

	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int init(const char *rest_addr, int rest_port);

	/*! @function
	********************************************************************************
	   : setAccount
	     : ˺šȫ˺
	     : [IN]  AccountSid      : û˺
			   [IN]  AccountToken    : ˺
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int setAccount(const char *AccountSid,  const char *AccountToken);

	/*! @function
	********************************************************************************
	   : setSubAccount
	     : ˺šȫ˺
	     : [IN]  SubAccountSid	 : û˺
			   [IN]  SubAccountToken : ˺
			   [IN]  VoIPAccount	 : ͨѶ˺
			   [IN]  VoIPPassword	 : ͨѶ
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int setSubAccount(const char *SubAccountSid,  const char *SubAccountToken, const char *VoIPAccount,const char *VoIPPassword);
	
	/*! @function
	********************************************************************************
	   : setAppId
	     : ӦIdȫӦId
	     : [IN]  appId       : ӦId

	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/	
	int setAppId(const char* appId);

	/*! @function
	********************************************************************************
	   : unInit
	     : ע
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int unInit();

	/*! @function
	********************************************************************************
	   : setLogLevel
	     : ־ڳʼǰ
	     : [IN]  Level : ֵԽ󣬴ӡԽϸ
	                        #define LOG_PACKAGE 5
							#define LOG_DEBUG   4
							#define LOG_INFO    3
							#define LOG_ERROR   2
							#define LOG_OPEN    1
							#define LOG_CLOSE   0
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int setLogLevel(int Level);

	
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//REST ӿڲ	

	//˻Ϣѯ
	/*! @function
	********************************************************************************
	   : queryAccountInfo
	     : ˻Ϣѯ˺Ž֤
	     : [out]  outData : Ӧ,ⲿڴ
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int queryAccountInfo(AccountInfo* outData);

	//˻
	/*! @function
	********************************************************************************
	   : createSubAccount
	     : ˻˺Ž֤
	     : [out] outData     : Ӧ,ⲿڴ		   
	           [IN]  friendlyName: ˻ơӢĸͰ˻ΨһƣƼʹõַ
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/	
    int createSubAccount(SubAccountOne* outData,const char* friendlyName);

	//ȡ˻
	/*! @function
	********************************************************************************
	   : getSubAccounts
	     : ѯ˻˺Ž֤
	     : [out] outData : Ӧ,ⲿڴ棬offset˻ռ
	           [IN]  startNo : ʼţĬϴ0ʼ
			   [IN]  offset  : һβѯС1100
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/	
	int getSubAccounts(SubAccounts* outData,int startNo, int offset);

	//˻Ϣѯ
	/*! @function
	********************************************************************************
	   : querySubAccount
	     : ˻Ϣѯ˺Ž֤
	     : [out] outData     : Ӧ,ⲿڴ
	           [IN]  friendlyName: ˻ơӢĸͰ˻ΨһƣƼʹõַ
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int querySubAccount(SubAccountOne* outData,const char* friendlyName);
	
	//ģ
	/*! @function
	********************************************************************************
	   : TemplateSMS
	     : ģš˺Ž֤
	     : [out] outData    : Ӧ,ⲿڴ
			   [IN]  to         : Žնֻ뼯ϣӢĶŷֿÿ͵ֻó100
	           [IN]  templateId : ģId 
			   [IN]  dataArr    : 顣滻ģ{}
	           [IN]  dataArrNum : ڳԱ 
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int sendTemplateSMS(SMSInfo* outData,const char* to,const char* templateId,const char** dataArr,int dataArrNum);

	//˫ز
	/*! @function
	********************************************************************************
	   : Callback
	     : ˫ز˺Ž֤
	     : [out] outData        : Ӧ,ⲿڴ
			   [IN]  from           : Сʱ׼,00++绰룻йڿʡΪ绰룬̻š
	           [IN]  to             : Сʱ׼00++绰룻йڿʡΪ绰룬̻š
			   [IN]  fromSerNum     : вʾĺ룬ƽ̨ԺŹơΪNULL
	           [IN]  customerSerNum : вʾĺ룬ƽ̨ԺŹơΪNULL
			   [IN]  promptTone : Զزʾ *.wavΪNULL
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int callBack (CallInfo* outData,const char* from, const char* to,const char* fromSerNum, const char* customerSerNum, const char* promptTone);

	//֪ͨ
	/*! @function
	********************************************************************************
	   : landingCall
	     : ֪ͨ˺Ž֤
	     : [out] outData       : Ӧ,ⲿڴ
			   [IN]  to            : к
	           [IN]  mediaName     : ļƣʽ wavmediaTxtͬʱΪNULLΪNULLʱmediaTxtʧЧ
			   [IN]  mediaNameType : ĬֵΪ0ʾûļֵΪ1ʾƽ̨ͨļ
			   [IN]  mediaTxt      : ıݣĬֵΪաΪNULL
	           [IN]  playTimes     : ѭŴ13ΣĬϲ1
			   [IN]  displayNum    : ʾк룬ʾȨɷơΪNULL
	           [IN]  respUrl       : ״̬֪ͨصַͨѶƽ̨Urlַͺн֪ͨΪNULL
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/	
	int landingCall(CallInfo* outData,const char* to,const char* mediaName,int mediaNameType,const char* mediaTxt,int playTimes, const char* diaplayNum,const char* respUrl);
 
	//֤
	/*! @function
	********************************************************************************
	   : voiceVerify
	     : ֤롣˺Ž֤
	     : [out] outData    : Ӧ,ⲿڴ
			   [IN]  to         : պ
	           [IN]  verifyCode : ֤ݣΪֺӢĸִСд4-8λ
	           [IN]  playTimes  : ѭŴ13ΣĬϲ1
			   [IN]  displayNum : ʾк룬ʾȨɷơΪNULL
	           [IN]  respUrl    : ״̬֪ͨصַͨѶƽ̨Urlַͺн֪ͨΪNULL
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int voiceVerify(CallInfo* outData,const char* to, const char* verifyCode, int playTimes,const char* diaplayNum,const char* respUrl);

	//IVR
	/*! @function
	********************************************************************************
	   : ivrDial 
	     : IVR˺Ž֤
	     : [out] outData  : Ӧ,ⲿڴ
			   [IN]  number   : к룬ΪDialڵ
	           [IN]  userdata : ûݣ<startservice>֪ͨзأֻдַΪDialڵԡΪNULL
	           [IN]  record   : Ƿ¼ΪtruefalseĬֵΪfalse¼ΪDialڵԡΪNULL
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int ivrDial (IVRCall* outData,const char* number, const char* userdata, bool record);

	//
	/*! @function
	********************************************************************************
	   : billRecords
	     : ء˺Ž֤
	     : [out] outData  : Ӧ,ⲿڴ
			   [IN]  date     : day ǰһݣ00:00 C 23:59;weekǰһܵ(һ )monthʾһµݣϸ±ʾǰ¼1410ţѯ3·ݵݣ
	           [IN]  keywords : ͻĲѯɿͻж岢ṩͨѶƽ̨ĬϲԴ˲ΪNULL
	ֵ   : Ƿɹ 0ɹ 0ʧ
	*******************************************************************************/
	int billRecords(BillRecord* outData,const char* date, const char* keywords);


#ifdef __cplusplus
}
#endif

#endif 
