/*
 *  Copyright (c) 2013 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.cloopen.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
// CommInterAdapter.h: interface for the CCommInterAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMINTERADAPTER_H__B720BF54_DCCC_448E_9012_6D9F19E6073A__INCLUDED_)
#define AFX_COMMINTERADAPTER_H__B720BF54_DCCC_448E_9012_6D9F19E6073A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>

#pragma pack (1)
typedef struct _UploadVoiceMsgRes
{
	//rest
	char voiceMessageSid[64];
	char uploadurl[512];
    char uploadtoken[33];
	char dateCreated[20];

	char from[33]; //ͷ
    char groupid[33];
	int  groupMemNum; //ȺԱ
	unsigned long filesize;//ļС
	//char fileName[256];//ļ·м仺ͻصֱһϴ

	int  duration;
	char ext[32];//ļչ

	int  restStatusCode;

    //fileServer
	int  fileStatusCode;
	//char statusmsg[128];

}UploadVoiceMsgRes;
#pragma pack ()

class ReqMessage
{
public:
	 ReqMessage(){
		Init();
	};
	~ ReqMessage()
	{
		if (m_pData)
		{
			delete m_pData;
			m_pData=NULL;
		}
		if (m_file)
		{
			delete m_file;
			m_file=NULL;
		}
		if (m_pFileUrl)
		{
			delete m_pFileUrl;
			m_pFileUrl=NULL;
		}
	/*	if (m_pUploadVoiceMsgRes)
		{
			delete m_pUploadVoiceMsgRes;
			m_pUploadVoiceMsgRes=NULL;
		}*/
		
	};
	void SetData(char *pData,int iSize)
	{
		if(m_pData) delete m_pData;
		m_pData =new char[iSize+1];//һֽڣռ'\0'
		memset(m_pData,0,iSize+1);
		m_iSize = iSize;
		memcpy(m_pData,pData,iSize);
	}
	void SetFile(char *pData,int iSize)
	{
		if(m_file) delete m_file;
		m_file =new char[iSize+1];
		memset(m_file,0,iSize+1);
		m_fileSize = iSize;
		memcpy(m_file,pData,iSize);
	}
	void SetFileUrl(char *pData,int iSize)
	{
		if(m_pFileUrl) delete m_pFileUrl;
		m_pFileUrl =new char[iSize+1];
		memset(m_pFileUrl,0,iSize+1);
		m_iFileUrlSize = iSize;
		memcpy(m_pFileUrl,pData,iSize);
	}
	//void SetUploadVoiceMsgRes(UploadVoiceMsgRes *pData)
	//{
	//	if(m_pUploadVoiceMsgRes) delete m_pUploadVoiceMsgRes;
	//	m_pUploadVoiceMsgRes =new UploadVoiceMsgRes;
	//	
	//	memcpy(m_pUploadVoiceMsgRes->dateCreated,pData->dateCreated,sizeof(m_pUploadVoiceMsgRes->dateCreated));
	//	memcpy(m_pUploadVoiceMsgRes->from,pData->from,sizeof(m_pUploadVoiceMsgRes->from));
	//	memcpy(m_pUploadVoiceMsgRes->groupid,pData->groupid,sizeof(m_pUploadVoiceMsgRes->groupid));
	//	memcpy(m_pUploadVoiceMsgRes->voiceMessageSid,pData->voiceMessageSid,sizeof(m_pUploadVoiceMsgRes->voiceMessageSid));
	//	memcpy(m_pUploadVoiceMsgRes->uploadurl,pData->uploadurl,sizeof(m_pUploadVoiceMsgRes->uploadurl));
	//	memcpy(m_pUploadVoiceMsgRes->uploadtoken,pData->uploadtoken,sizeof(m_pUploadVoiceMsgRes->uploadtoken));

	//	m_pUploadVoiceMsgRes->filesize=pData->filesize;
	//	m_pUploadVoiceMsgRes->groupMemNum=pData->groupMemNum;
	//	m_pUploadVoiceMsgRes->duration=pData->duration;
	//	m_pUploadVoiceMsgRes->restStatusCode=pData->restStatusCode;
	//	m_pUploadVoiceMsgRes->fileStatusCode=pData->fileStatusCode;
	//}
private:
	void Init()
	{
		m_pData = 0L;
		m_iSize = 0;
        nMessageID=-1;
		m_file=NULL;
		m_fileSize=0;
		m_pFileUrl=NULL;
		m_iFileUrlSize=0;
		num=0;

	/*	m_pUploadVoiceMsgRes=NULL;*/
		
	}

public:


	 ReqMessage:: ReqMessage(const  ReqMessage& message)
	{	
		Init();
		*this = message;
	}
	
	 ReqMessage& operator=(const  ReqMessage& src)
	{
		if(this == &src)
			return *this;
		
		if(m_pData)
		{
			delete m_pData;
			m_pData=NULL;
		}
		if(NULL!=src.m_pData)
		{
		m_pData = new char[src.m_iSize+1];
		memset(m_pData,0,src.m_iSize+1);
		memcpy(m_pData,src.m_pData,src.m_iSize);
		m_iSize = src.m_iSize;
		}

		if(m_file)
		{
			delete m_file;
			m_file=NULL;
		}
		if(NULL!=src.m_file)
		{
		m_file = new char[src.m_fileSize+1];
		memset(m_file,0,src.m_fileSize+1);
		memcpy(m_file,src.m_file,src.m_fileSize);
		m_fileSize = src.m_fileSize;
		}

		if(m_pFileUrl)
		{
			delete m_pFileUrl;
			m_pFileUrl=NULL;
		}
		if(NULL!=src.m_pFileUrl)
		{
		m_pFileUrl = new char[src.m_iFileUrlSize+1];	
		memset(m_pFileUrl,0,src.m_iFileUrlSize+1);
		memcpy(m_pFileUrl,src.m_pFileUrl,src.m_iFileUrlSize);
		m_iFileUrlSize = src.m_iFileUrlSize;
		}
		num = src.num;
		nMessageID = src.nMessageID;

		//if(m_pUploadVoiceMsgRes)
		//{
		//	delete m_pUploadVoiceMsgRes;
		//m_pUploadVoiceMsgRes=NULL;
		//}
		//if(NULL!=src.m_pUploadVoiceMsgRes)
		//{
		//m_pUploadVoiceMsgRes =new UploadVoiceMsgRes;
		//memcpy(m_pUploadVoiceMsgRes->dateCreated,src.m_pUploadVoiceMsgRes->dateCreated,sizeof(m_pUploadVoiceMsgRes->dateCreated));
		//memcpy(m_pUploadVoiceMsgRes->from,src.m_pUploadVoiceMsgRes->from,sizeof(m_pUploadVoiceMsgRes->from));
		//memcpy(m_pUploadVoiceMsgRes->groupid,src.m_pUploadVoiceMsgRes->groupid,sizeof(m_pUploadVoiceMsgRes->groupid));
		//memcpy(m_pUploadVoiceMsgRes->voiceMessageSid,src.m_pUploadVoiceMsgRes->voiceMessageSid,sizeof(m_pUploadVoiceMsgRes->voiceMessageSid));
		//memcpy(m_pUploadVoiceMsgRes->uploadurl,src.m_pUploadVoiceMsgRes->uploadurl,sizeof(m_pUploadVoiceMsgRes->uploadurl));
		//memcpy(m_pUploadVoiceMsgRes->uploadtoken,src.m_pUploadVoiceMsgRes->uploadtoken,sizeof(m_pUploadVoiceMsgRes->uploadtoken));

		//m_pUploadVoiceMsgRes->filesize=src.m_pUploadVoiceMsgRes->filesize;
		//m_pUploadVoiceMsgRes->groupMemNum=src.m_pUploadVoiceMsgRes->groupMemNum;
		//m_pUploadVoiceMsgRes->duration=src.m_pUploadVoiceMsgRes->duration;
		//m_pUploadVoiceMsgRes->restStatusCode=src.m_pUploadVoiceMsgRes->restStatusCode;
		//m_pUploadVoiceMsgRes->fileStatusCode=src.m_pUploadVoiceMsgRes->fileStatusCode;
		//}
		return *this;
	};

public:

	int nMessageID;   //Ϣid
	unsigned long num;		  //
	char* m_file;//ļ·,
	int m_fileSize;//ļ
	char* m_pFileUrl;//
	int m_iFileUrlSize;//
	char* m_pData;    //
	int m_iSize;

	//UploadVoiceMsgRes *m_pUploadVoiceMsgRes;
	
};



#endif // !defined(AFX_COMMINTERADAPTER_H__B720BF54_DCCC_448E_9012_6D9F19E6073A__INCLUDED_)
