/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
#ifndef _SDK_REST_CLIENT_H
#define _SDK_REST_CLIENT_H

#include "HttpClient.h"
#include "CCPRestDefine.h"

#define REST_OK   0

enum {
	ERR_NULL =171300,
	ERR_MD5_BASE64,
	ERR_SYN_HTTP_REQUEST,//socketʧ
	ERR_SYN_HTTP_STATAUS_CODE,
	ERR_CREATE_FILE,
	ERR_XML_NODE,
	ERR_XML_ELEMENT,
	ERR_XML_STATAUS_CODE,
	ERR_XML_FILESTATAUS_CODE,
	ERR_QUEUE_EMPTY,
	ERR_XML_SWITCHIP_NULL,
	ERR_ENCODE_HTTP,
	ERR_RECV_NULL,
	ERR_BODY_NULL,//ݿ
	ERR_HEAD_LARGE,//ͷ̫
	ERR_RESPONSE_CONTENT_LENGTH,//ضư峤
	ERR_CANCEL_UP_OR_DOWM_NOW,//ⲿȡϴ
	ERR_SEND_WSAECONNRESET,//·Զ˸λ
	ERR_RECV_BLOCK,//ʱ
	ERR_UNICODE_TO_UTF8_MORE_LEN,//ַ̫
};
#define ERR_STR_SYN_HTTP_STATAUS_CODE "ʧܣhttpЭ׼"
#define ERR_STR_SYN_HTTP_REQUEST "socketʧ"


enum {
     REST_HTTP_BODY_TYPE_XML= 0x00,
     REST_HTTP_BODY_TYPE_JSON,

};

class TRestClient {

public:
	TRestClient(int bodyType,const char *p_restaddr, int restport, const char *p_mainaccount,  const char *p_mainaccountpwd,const char *p_subaccount,  const char *p_subaccountpwd, const char *p_voipid,const char *p_voippwd);
	~TRestClient();

	/* 2014-0429
	1˺Ϣѯ 2˺ 3ȡ˺  4˺Ϣѯ 5ģ
	6֪ͨ 7֤  8IVR 9
	*/
	int synQueryAccountInfo(AccountInfo* outData);//ѯ˺
	int synCreateSubAccount(SubAccountOne* outData,const char* appId,const char* friendlyName);//˺
	int synQuerySubAccounts(SubAccounts* outData,const char* appId,int startNo, int offset);//ѯ˻
	int synQuerySubAccountByName(SubAccountOne* outData,const char* appId,const char* friendlyName);//ѯ˺
	int synSendTemplateSMS(SMSInfo* outData,const char* appId,const char* to,const char* templateId,const char** dataArr,int dataArrNum);//ģ
	int synLandingCalls(CallInfo* outData,const char* appId,const char* to,const char* mediaName,const char* mediaTxt,int playTimes, const char* diaplayNum,const char* respUrl,const char* userData,const char* txtSpeed,const char* txtVolume,const char* txtPitch,const char* txtBgsound,const char* playMode);//֪ͨ
    int synVoiceVerifyCode(CallInfo* outData,const char* appId,const char* to, const char* verifyCode, int playTimes,const char* diaplayNum,const char* respUrl,const char* lang,const char* welcomePrompt,const char* playVerifyCode,const char* maxCallTime);//֤
	int synIvrDial(IVRCall* outData,const char* appId,const char* number, const char* userdata, bool record,const char* disnumber);//IVR
	int synGetBillRecordsURL(BillRecord* outData,const char* appId,const char* date, const char* keywords);//ûصַ

private:
	int Md5AndBase64(const char* account, const char* accountpwd,char* mdrstr, char* base64str);

public:

	char m_subaccount[33];
	char m_subaccountpwd[33];
	char m_voipid[33];
	char m_voippwd[33];
	char m_mainaccount[33];
	char m_mainaccountpwd[33];
private:
    char m_server[64];
	int  m_port;

	char m_RestVersion[20];//汾пܱ仯
	char m_https[10];//пhttpЭ
	bool m_bUseSSL;//restӿǷhttpsssl,Ĭhttps, httpֺ֧ͷַݴ
	int  m_BodyType;//body װʽ0 xml,1 json
};


#endif