/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
#ifndef _HTTP_CLIENT_H
#define _HTTP_CLIENT_H

#include <string>
#include "http.h"
#ifdef WIN32
#include <WinSock2.h>
#include <WS2tcpip.h>
#endif

#define SUPPORT_SSL

#ifdef SUPPORT_SSL
#include "openssl/bio.h" 
#include "openssl/ssl.h" 
#include "openssl/err.h" 
#endif

typedef void (*HttpResponseCallBack)(THttpResponse &response, bool success);
typedef void (*TRACE_FUNC) (const char *, ...);
class THttpClient {

public:
	THttpClient(std::string server, int port, bool bUseSSL);
	~THttpClient();
	bool SynHttpRequest(THttpRequest& reqest,THttpResponse &response );//ÿηһΪṹ
	bool SynHttpRequestData(char *data,int datalen ,int timeOUT,THttpResponse &response );//ʱ,ΪװźĶ
	bool AsynHttpRequest(THttpRequest& reqest,HttpResponseCallBack callback );
	bool SynHttpSetup(int family,int socktype,int protocol);//ӣ socket,
	const std::string &GetErrorMessage(){ return m_errorMsg;}
	void SetTraceFunc(TRACE_FUNC trace_func);
	

	//ӣҪѷͽսӿڱ¶
	int sendHttpRequestData(char *outputData,int msglen);//ͣΪźĶ
	int recvHttpResponseData(char *inputData,int buflen);//հ,յĶ
	int recvHttpResponse(THttpResponse& response);//հ

	int m_socket;
private:
	int sendHttpRequest(THttpRequest& request);//Ϊṹ壬ǰ
	int recvHttpsTimeoutResponse(THttpResponse& response,int timeOUT);//httpsʱհóʱΪӰrest server߼rest serverĬϳʱ30s
	void Trace(const char*fmt,...);

	std::string m_server;
	std::string m_errorMsg;
	int m_port;
	bool m_bUseSSL;
	//int m_socket;
	TRACE_FUNC m_pTraceFun;
#ifdef SUPPORT_SSL
	SSL_CTX* m_ssl_ctx;
	SSL *m_ssl;
#endif

};

#endif