/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
// YYLog.h: interface for the CYYLog class.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_YYLOG_H__E4806855_2FD8_4D87_A40C_2DCF262EF185__INCLUDED_)
#define AFX_YYLOG_H__E4806855_2FD8_4D87_A40C_2DCF262EF185__INCLUDED_


#include "common.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define LOG_FILE_SIZE 50*1024*1024
#define CONTENT_SIZE 10*2048

//־
#define LOG_PACKAGE 5
#define LOG_DEBUG   4
#define LOG_INFO    3
#define LOG_ERROR   2
#define LOG_OPEN    1
#define LOG_CLOSE   0

#ifndef YY
#define YY

#ifdef  UNICODE    
typedef LPCWSTR YYPCSTR ;
typedef LPWSTR  YYPSTR ;
typedef wchar_t YYCHAR ;
typedef const wchar_t YYCCHAR ;
#else
typedef char   YYCHAR ;
typedef const char YYCCHAR ;
typedef const char* YYPCSTR ;
typedef char*  YYPSTR ;
#endif

#endif	

#define YY_DATETIME_FORMAT "%Y-%m-%d %H:%M:%S"
typedef struct logContent 
{
	YYCHAR	m_timestr[128];
	YYCHAR    m_type[64];
	YYCHAR	m_content[CONTENT_SIZE];
}LOGCONTENT;

class CYYLog  
{
public:
	int WriteLog(YYPCSTR typeInfo, YYPCSTR  format);
	char m_fileName[256];
	CYYLog();
	CYYLog(char* szFileName);
	virtual ~CYYLog();

private:
	FILE* mCurFile;
	int m_fileIndex ;
	int m_writeLength ;

	static YYCHAR m_contentBuff[CONTENT_SIZE+256];
	void GetNowTimeStr(YYPSTR sztimeStr);
};

#if _MY_WINDOWS_
extern void YYLog(YYPCSTR typeInfo,YYPCSTR  format, ...);
#elif _MY_LINUX64_
extern void YYLog(YYPCSTR typeInfo,YYPCSTR  format,...);
#endif
extern int  m_bLogLevel;
/*

YYCHAR* char2wchar(char * from);
char* wchar2char(YYCHAR * from);

*/
#endif // !defined(AFX_YYLOG_H__E4806855_2FD8_4D87_A40C_2DCF262EF185__INCLUDED_)
