/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
#ifndef _COM_TIME_H_
#define _COM_TIME_H_

#define _MY_WINDOWS_ 1
//#define _MY_LINUX64_ 0

#include<time.h>
#if _MY_WINDOWS_
#include<process.h>
#include<windows.h>
#elif _MY_LINUX64_
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/time.h>
#include <errno.h>
#endif

#include <sys/types.h> 
#include <sys/timeb.h> 

#if _MY_WINDOWS_
//typedef unsigned int uInt;
typedef unsigned char uChar;
	//typedef unsigned long uLong;
typedef unsigned long long int uIn64;
typedef unsigned int uIn32;
typedef unsigned short uIn16;
#elif _MY_LINUX64_
	typedef unsigned int uInt;
	typedef unsigned char uChar;
	//typedef unsigned int uLong;
	typedef unsigned long uIn64;
	typedef unsigned int uIn32;
	typedef unsigned short uIn16;
#endif



typedef struct t_timeval
{
	uIn32       tv_sec;
	uIn32       tv_usec;
}TIMEVAL8;

typedef struct  
{
	char ntype;
	uChar ip[4];
}CHAR_IP;

typedef unsigned int (__stdcall *threadProc)(void* ); 

int GetNowWeek(); //[1..7]
int GetNowTime(); //صǰʱ 
int	GetSetTime(time_t setTime);
time_t FormatNowDate(char* format,char* dest,int Maxsize);
void FormatSetDate(char* format,time_t Datetime,char* dest,int Maxsize);
extern void GetMillisecondTimeFmt(char* _out_date);
extern uIn64 GetMillisecondTimeLong(TIMEVAL8* out_time =NULL) ;
extern void GetMillisecondTimeFmt_TIME(char* _out_date);
extern void GetSecondTimeFmt_yyyyMMddHHmmss(char* _out_date);

extern int unicode_to_utf8(char* szUnicode,char* dest,int dst_len);
extern int utf8_to_unicode(char* szU8,char* dest,int dst_len) ;
extern void my_sleep(DWORD uSec);
extern uIn32 my_ntohl32(uIn32 netInt);
extern uIn16 my_ntohs(uIn16 netShort);
//extern void Debug_print_hex(char* pData, int length);
extern int yy_check_and_mkdirs(char* path);
extern void getNameFromDirName(char* name,char* dir,int maxlen);
extern void getExtensionNameFromDirName(char* name,char* dir,int maxlen);
extern int is_match_ip_com(CHAR_IP* QQserverIPs,int size, uChar* arrayIps);
extern int is_match_ip(uChar* ip1,uChar* ip2);
extern uIn64 my_str_2_int64(char* data);

extern HANDLE CreateYYThread(void* param, threadProc proc,int level = 0);

#endif


