//#include < windows.h >

#include "CCPRestClient.h"
#include "RestClient.h"
#include "common.h"
#include "YYLog.h"


static TRestClient  *g_pSerCore = NULL;
static char m_appId[64];
extern "C" int init(const char *rest_addr, int rest_port)
{

	if(!rest_addr) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","init, ret=%d,rest_addr=NULL",ERR_LOCAL_IP_NULL);
		}
		return ERR_LOCAL_IP_NULL;
	}
	if((strlen(rest_addr)<=0))
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","init,ret=%d,rest_addr=%s",rest_addr,ERR_LOCAL_IP_NULL);
		}
		return ERR_LOCAL_IP_NULL;
	}
	if(rest_port<=0)
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","init, ret=%d,rest_port=%d",rest_port,ERR_LOCAL_IP_PORT);
		}
		return ERR_LOCAL_IP_PORT;
	}
	g_pSerCore =new TRestClient(REST_HTTP_BODY_TYPE_XML,rest_addr, rest_port, "","","","","","");
	memset(m_appId,0,sizeof(m_appId));

	return 0;

}
extern "C" int setAccount(const char *AccountSid,  const char *AccountToken)
{

	if((!AccountSid)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setAccount, ret=%d,AccountSid=NULL",ERR_LOCAL_ACCOUNT_NULL);
		}
		return ERR_LOCAL_ACCOUNT_NULL;
	}
	if((strlen(AccountSid)<=0))
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setAccount, ret=%d,AccountSid=%s",ERR_LOCAL_ACCOUNT_NULL,AccountSid);
		}
		return ERR_LOCAL_ACCOUNT_NULL;
	}
	if((!AccountToken)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setAccount, ret=%d,AccountToken=NULL",ERR_LOCAL_ACCOUNT_TOKEN_NULL);
		}
		return ERR_LOCAL_ACCOUNT_TOKEN_NULL;
	}
	if((strlen(AccountToken)<=0))
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setAccount, ret=%d,AccountToken=%s",ERR_LOCAL_ACCOUNT_TOKEN_NULL,AccountToken);
		}
		return ERR_LOCAL_ACCOUNT_TOKEN_NULL;
	}
	memset(g_pSerCore->m_mainaccount,0,sizeof(g_pSerCore->m_mainaccount));
	memset(g_pSerCore->m_mainaccountpwd,0,sizeof(g_pSerCore->m_mainaccountpwd));

	strncpy(g_pSerCore->m_mainaccount,AccountSid,sizeof(g_pSerCore->m_mainaccount));
	g_pSerCore->m_mainaccount[sizeof(g_pSerCore->m_mainaccount)-1]='\0';
	strncpy(g_pSerCore->m_mainaccountpwd,AccountToken,sizeof(g_pSerCore->m_mainaccountpwd));
	g_pSerCore->m_mainaccountpwd[sizeof(g_pSerCore->m_mainaccountpwd)-1]='\0';
	if(m_bLogLevel>=LOG_INFO)
	{
	YYLog("CCPRestClient","setAccount,mainaccount:%s",g_pSerCore->m_mainaccount);
	}
	return 0;

}
extern "C" int setSubAccount(const char *SubAccountSid,  const char *SubAccountToken, const char *VoIPAccount,const char *VoIPPassword)
{

	if((!SubAccountSid)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setSubAccount, ret=%d,SubAccountSid=NULL",ERR_LOCAL_SUBACCOUNT_NULL);
		}
		return ERR_LOCAL_SUBACCOUNT_NULL;
	}
	if((strlen(SubAccountSid)<=0))
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setSubAccount, ret=%d,SubAccountSid=%s",ERR_LOCAL_SUBACCOUNT_NULL,SubAccountSid);
		}
		return ERR_LOCAL_SUBACCOUNT_NULL;
	}

	if((!SubAccountToken)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setSubAccount, ret=%d,SubAccountToken=NULL",ERR_LOCAL_SUBACCOUNT_TOKEN_NULL);
		}
		return ERR_LOCAL_SUBACCOUNT_TOKEN_NULL;
	}
	if((strlen(SubAccountToken)<=0))
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setSubAccount, ret=%d,SubAccountToken=%s",ERR_LOCAL_SUBACCOUNT_TOKEN_NULL,SubAccountToken);
		}
		return ERR_LOCAL_SUBACCOUNT_TOKEN_NULL;
	}

	if((!VoIPAccount)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setSubAccount, ret=%d,VoIPAccount=NULL",ERR_LOCAL_VOIP_NULL);
		}
		return ERR_LOCAL_VOIP_NULL;
	}
	//if((strlen(VoIPAccount)<=0))
	//{
	//	if(m_bLogLevel>=LOG_DEBUG)
	//	{
	//		YYLog("CCPRestClient","setSubAccount, ret=%d,VoIPAccount=%s",ERR_LOCAL_VOIP_NULL,VoIPAccount);
	//	}
	//	return ERR_LOCAL_VOIP_NULL;
	//}

	if((!VoIPPassword)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setSubAccount, ret=%d,VoIPPassword=NULL",ERR_LOCAL_VOIP_TOKEN_NULL);
		}
		return ERR_LOCAL_VOIP_TOKEN_NULL;
	}
	//if((strlen(VoIPPassword)<=0))
	//{
	//	if(m_bLogLevel>=LOG_DEBUG)
	//	{
	//		YYLog("CCPRestClient","setSubAccount, ret=%d,VoIPPassword=%s",ERR_LOCAL_VOIP_TOKEN_NULL,VoIPPassword);
	//	}
	//	return ERR_LOCAL_VOIP_TOKEN_NULL;
	//}

	memset(g_pSerCore->m_subaccount,0,sizeof(g_pSerCore->m_subaccount));
	memset(g_pSerCore->m_subaccountpwd,0,sizeof(g_pSerCore->m_subaccountpwd));
	memset(g_pSerCore->m_voipid,0,sizeof(g_pSerCore->m_voipid));
	memset(g_pSerCore->m_voippwd,0,sizeof(g_pSerCore->m_voippwd));

	strncpy(g_pSerCore->m_subaccount,SubAccountSid,sizeof(g_pSerCore->m_subaccount));
	g_pSerCore->m_subaccount[sizeof(g_pSerCore->m_subaccount)-1]='\0';
	strncpy(g_pSerCore->m_subaccountpwd,SubAccountToken,sizeof(g_pSerCore->m_subaccountpwd));
	g_pSerCore->m_subaccountpwd[sizeof(g_pSerCore->m_subaccountpwd)-1]='\0';
	strncpy(g_pSerCore->m_voipid,VoIPAccount,sizeof(g_pSerCore->m_voipid));
	g_pSerCore->m_voipid[sizeof(g_pSerCore->m_voipid)-1]='\0';
	strncpy(g_pSerCore->m_voippwd,VoIPPassword,sizeof(g_pSerCore->m_voippwd));
	g_pSerCore->m_voippwd[sizeof(g_pSerCore->m_voippwd)-1]='\0';
	if(m_bLogLevel>=LOG_INFO)
	{
	YYLog("CCPRestClient","setSubAccount, subaccount:%s, voipid:%s",g_pSerCore->m_subaccount,g_pSerCore->m_voipid);
	}
	return 0;

}
extern "C" int setAppId(const char* appId)
{

	if((!appId)) 
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setAppId, ret=%d,appId=NULL",ERR_LOCAL_APPID_NULL);
		}
		return ERR_LOCAL_APPID_NULL;
	}
	if((strlen(appId)<=0))
	{
		if(m_bLogLevel>=LOG_DEBUG)
		{
			YYLog("CCPRestClient","setAppId, ret=%d,appId=%s",ERR_LOCAL_APPID_NULL,appId);
		}
		return ERR_LOCAL_APPID_NULL;
	}

	memset(m_appId,0,sizeof(m_appId));

	strncpy(m_appId,appId,sizeof(m_appId));
	m_appId[sizeof(m_appId)-1]='\0';
	if(m_bLogLevel>=LOG_INFO)
	{
	YYLog("CCPRestClient","setAppId,m_appId:%s",m_appId);
	}
	return 0;

}
extern "C" int unInit()
{	
	if(NULL!=g_pSerCore)
	{
		delete g_pSerCore;
		g_pSerCore=NULL;
	}
	return 0;

}

extern "C" int setLogLevel(int Level)
{
	m_bLogLevel=Level;
	return 0;

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//rest ӿ
extern "C" int queryAccountInfo(AccountInfo* outData)
{
	return g_pSerCore->synQueryAccountInfo(outData);
}
extern "C" int createSubAccount(SubAccountOne* outData,const char* friendlyName)
{
	return g_pSerCore->synCreateSubAccount(outData,m_appId,friendlyName);
}
extern "C" int getSubAccounts(SubAccounts* outData,int startNo, int offset)
{
	return g_pSerCore->synQuerySubAccounts(outData,m_appId,startNo,offset);
	//return 0;
}
extern "C" int querySubAccount(SubAccountOne* outData,const char* friendlyName)
{
	return g_pSerCore->synQuerySubAccountByName(outData,m_appId,friendlyName);
}
extern "C" int sendTemplateSMS(SMSInfo* outData,const char* to,const char* templateId,const char** dataArr,int dataArrNum)
{
	return g_pSerCore->synSendTemplateSMS(outData,m_appId,to,templateId,dataArr,dataArrNum);
}
extern "C" int landingCall(CallInfo* outData,const char* to,const char* mediaName,const char* mediaTxt,int playTimes, const char* diaplayNum,const char* respUrl,const char* userData,const char* txtSpeed,const char* txtVolume,const char* txtPitch,const char* txtBgsound,const char* playMode)
{
	return g_pSerCore->synLandingCalls(outData,m_appId,to,mediaName,mediaTxt,playTimes, diaplayNum,respUrl,userData,txtSpeed,txtVolume,txtPitch,txtBgsound,playMode);
}
extern "C" int voiceVerify(CallInfo* outData,const char* to, const char* verifyCode, int playTimes,const char* diaplayNum,const char* respUrl,const char* lang ,const char* welcomePrompt,const char* playVerifyCode,const char* maxCallTime)
{
	return g_pSerCore->synVoiceVerifyCode(outData, m_appId,to,verifyCode, playTimes,diaplayNum,respUrl,lang,welcomePrompt,playVerifyCode,maxCallTime);
}
extern "C" int ivrDial(IVRCall* outData,const char* number, const char* userdata, bool record,const char* disnumber)
{
	return g_pSerCore->synIvrDial(outData,m_appId,number, userdata, record,disnumber);
}
extern "C" int billRecords(BillRecord* outData,const char* date, const char* keywords)
{
	return g_pSerCore->synGetBillRecordsURL(outData,m_appId,date, keywords);
	//return 0;
}
















