/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
// YYLog.cpp: implementation of the CYYLog class.
//
//////////////////////////////////////////////////////////////////////


#include "YYLog.h"




/*#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif*/
/*

YYCHAR* char2wchar(char * from)
{
	static YYCHAR buff[512]={0};
	size_t len=0;
	mbstowcs_s(&len ,buff,strlen(from)+1,from,_TRUNCATE);
	return buff;
}

char* wchar2char(YYCHAR * from)
{
	static char buff[512]={0};
	size_t len=0;
	wcstombs_s(&len ,buff,::wcslen(from)*2,from,_TRUNCATE);
	return buff;
}

*/


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//Ĭ־
int  m_bLogLevel=LOG_PACKAGE ;//LOG_INFO   LOG_DEBUG  LOG_PACKAGE
YYCHAR CYYLog::m_contentBuff[CONTENT_SIZE+256]={0};

CYYLog::CYYLog()
{
	sprintf(m_fileName,"");
	m_fileIndex = 0;
	m_writeLength = 0;
	mCurFile = NULL;
}

CYYLog::CYYLog(char* szFileName)
{
	sprintf(m_fileName,szFileName);
	m_fileIndex = 0;
	m_writeLength = 0;
	mCurFile = NULL;
}

CYYLog::~CYYLog()
{
	if(mCurFile!=NULL)
	{
		fclose(mCurFile);
		mCurFile = NULL;
	}
}


int CYYLog::WriteLog(YYPCSTR typeInfo,YYPCSTR  format)
{
	LOGCONTENT  logBuff = {0};

	if(	mCurFile == NULL || m_writeLength > LOG_FILE_SIZE)
	{
		if(mCurFile!=NULL)
		{
			fclose(mCurFile);
			mCurFile = NULL;
		}

		char curFile[256] = {0};
#if _MY_WINDOWS_
		//sprintf(curFile,"%s\\log%d.log",m_fileName,++m_fileIndex);
		sprintf(curFile,".\\CCPRestSDK_%d.log",++m_fileIndex);
#elif _MY_LINUX64_
		sprintf(curFile,"%s/log%d.log",m_fileName,++m_fileIndex);
#endif
		mCurFile = fopen(curFile,"wb");
		if(mCurFile==NULL)
		{
			printf("open file error ");
			return 0;
		}
		m_writeLength = 0;
	}
	
 
    strncpy(logBuff.m_content,format, CONTENT_SIZE);
	logBuff.m_content[CONTENT_SIZE-1] = '\0';

	GetNowTimeStr(logBuff.m_timestr);
	if (typeInfo=="" || strlen(typeInfo) > 256)
	strcpy((char*)typeInfo,"INFO");
	sprintf(logBuff.m_type," [%s] ",typeInfo);

	//ZeroMemory(m_contentBuff,sizeof(m_contentBuff));
	sprintf(m_contentBuff,"%s%s%s%s",logBuff.m_timestr,
									 logBuff.m_type,
									 logBuff.m_content,"\r\n");

	if (!mCurFile) return 0;

	#ifdef  UNICODE 
	static short header= 0xFEFF;
	if (header!=0)
	{
		fwrite(&header,2,sizeof(YYCHAR)-1,pf);
		header=0;
	}
	#endif

	int inLen = (strlen((YYPCSTR)m_contentBuff)*sizeof(YYCHAR));
	fwrite(m_contentBuff,inLen,1,mCurFile);
	fflush(mCurFile);
	m_writeLength += inLen;

	
	return 1;
}

void inline CYYLog::GetNowTimeStr(YYPSTR sztimeStr)
{
	/*
	SYSTEMTIME sys; 
	GetLocalTime( &sys ); 	
	wsprintf(sztimeStr,TEXT("[%4d-%02d-%02d %02d:%02d:%02d.%03d]" ),sys.wYear,sys.wMonth,sys.wDay 
		,sys.wHour,sys.wMinute,sys.wSecond,sys.wMilliseconds 
			               ,sys.wDayOfWeek);
						   */

	FormatNowDate(YY_DATETIME_FORMAT,sztimeStr,128);

	return;
}

#if _MY_WINDOWS_
void YYLog(YYPCSTR typeInfo,YYPCSTR  format, ...)
{
	YYCHAR  logBuff[CONTENT_SIZE]={0};
	YYCHAR  logBuff1[CONTENT_SIZE]={0};
	va_list vl;

	va_start(vl, format);
	_vsnprintf(logBuff,CONTENT_SIZE,format, vl);
	va_end(vl);	

	static CYYLog* log=NULL;
	if (!log)
	{
		//char fileName[128] = {0};
		//if(1==g_main_config.pInitConfig->cfgGetContent("LogDir",fileName,128))	
		//	log=new CYYLog(fileName);
		//else
			log=new CYYLog("");
	}else
	{
		if(!stricmp("stopYYLog",typeInfo))
		{
			delete log;
			log=NULL;
			return;
		}
	}
	//Ĵ
	int sub_len = unicode_to_utf8(logBuff,logBuff1,CONTENT_SIZE);
	if(sub_len<=0)
	{
		log->WriteLog(typeInfo,logBuff);
	}else
	{
		log->WriteLog(typeInfo,logBuff1);
	}
	//log->WriteLog(typeInfo,logBuff);
}
#elif _MY_LINUX64_
void YYLog(YYPCSTR typeInfo,YYPCSTR  format, ...)
{
	YYCHAR  logBuff[CONTENT_SIZE]={0};

	va_list argp;

	va_start(argp,format);
	vsnprintf(logBuff,CONTENT_SIZE,format, argp);
	va_end(argp);

	static CYYLog* log=NULL;
	if (!log)
	{
		//char fileName[128] = {0};
		//if(1==g_main_config.pInitConfig->cfgGetContent("LogDir",fileName,128))	
		//	log=new CYYLog(fileName);
		//else
			log=new CYYLog("");
	}

	log->WriteLog(typeInfo,logBuff);
}
#endif

